function setup ()
{
    try {
        var iframe = document.getElementById ("edit-frame");

        var myIframeEditor = document.getElementById ("edit-frame").contentWindow
            .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
            .getInterface(Components.interfaces.nsIWebNavigation)
            .QueryInterface(Components.interfaces.nsIDocShell)
            .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
            .getInterface(Components.interfaces.nsIEditingSession)
            .getEditorForWindow(iframe.contentWindow);

        InlineSpellCheckerUI.init (myIframeEditor);
        InlineSpellCheckerUI.enabled = true;
    } catch (e) {
        window.alert (e);
    }
}

function _setMenuItemVisibility (id, visible)
{
    document.getElementById(id).hidden = ! visible;
}

function _doPopupItemDisabling ()
{
    if (InlineSpellCheckerUI) {
        InlineSpellCheckerUI.clearSuggestionsFromMenu();
        InlineSpellCheckerUI.clearDictionaryListFromMenu();
    }
}

function _doPopupItemEnablingSpell (popupNode, evt)
{
    var logger = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);

    if (!InlineSpellCheckerUI || !InlineSpellCheckerUI.canSpellCheck) {
        _setMenuItemVisibility("spell-no-suggestions", false);
        _setMenuItemVisibility("spell-check-enabled", false);
        _setMenuItemVisibility("spell-check-separator", false);
        _setMenuItemVisibility("spell-add-to-dictionary", false);
        _setMenuItemVisibility("spell-suggestions-separator", false);
        _setMenuItemVisibility("spell-dictionaries", false);
        return;
    }

    try { 
        InlineSpellCheckerUI.initFromEvent(document.popupRangeParent,
                document.popupRangeOffset);

        var enabled = InlineSpellCheckerUI.enabled;
        document.getElementById("spell-check-enabled").setAttribute("checked", enabled);

        var overMisspelling = InlineSpellCheckerUI.overMisspelling;

        _setMenuItemVisibility("spell-add-to-dictionary", overMisspelling);
        _setMenuItemVisibility("spell-suggestions-separator", overMisspelling);

        // suggestion list
        var numsug = InlineSpellCheckerUI.addSuggestionsToMenu(popupNode, document.getElementById("spell-no-suggestions"), 5);

        _setMenuItemVisibility("spell-no-suggestions", overMisspelling && numsug == 0);

        // dictionary list
        var numdicts = InlineSpellCheckerUI.addDictionaryListToMenu
            (document.getElementById("spell-dictionaries-menu"), null);
        _setMenuItemVisibility("spell-dictionaries", enabled && numdicts > 1);

    } catch (e) {
        window.alert (e);
    }
}
