/* -*- Mode: Java; tab-width: 2; c-basic-offset: 2; -*-
 * 
 * The contents of this file are subject to the Netscape Public License
 * Version 1.0 (the "NPL"); you may not use this file except in
 * compliance with the NPL.  You may obtain a copy of the NPL at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the NPL is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the NPL
 * for the specific language governing rights and limitations under the
 * NPL.
 *
 * The Initial Developer of this code under the NPL is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation.  All Rights
 * Reserved.
 *
 * Contributor(s):
 *  Doug Daniels <rainking@rice.edu> -- morphed code for Helper Applications pref window
 *                                      into multiple servers pref window for Annozilla
 */

var gServerURL = null;
var gDS = null;

/**
 * Initializes the window.  
 */
function Startup()
{
    // set up the ok and cancel buttons to call onOK when ok pressed
    doSetOKCancel(onOK);

    gServerURL = document.getElementById("serverURL");
    gServerURL.focus();
    var hasLocal = window.arguments[0];
    if (hasLocal) {
        document.getElementById("serverType").value = "remote";
        document.getElementById("serverType").disabled = true;
    }
    sizeToContent();
    moveToAlertPosition();
}

/**
 * Called when okOK pressed.  Stores the input
 * fields as RDF.
 */
function onOK()
{
    // Make sure all fields are filled in OK.
    if ( !checkInput() ) {
        window.alert("Please enter a valid URL"); // TODO i18n
        return false;
    }

    // get the servers RDF file
    var file = getServersFile();

    // open the file to a datasource
    gDS = getDatasource (file);

    // get the Bag in container
    var container = Components.classes["@mozilla.org/rdf/container;1"].createInstance();
    container = container.QueryInterface(Components.interfaces.nsIRDFContainer);

    // initialize the container to the root urn
    var containerRes = gRDF.GetResource(SERVERS_ROOT_URN);
    container.Init(gDS, containerRes);
    
    var serverUrl;
    if (document.getElementById("serverType").value == "local") {
        serverUrl = "urn:localserver";
    } else {
        serverUrl = gServerURL.value;
        // if the server URL doesn't contain a //, prepend http
        if (! serverUrl.match(/\/\//) ) {
            serverUrl = "http://" + serverUrl;
        }    
    }

    // create a new li element for the new server URL
    var element = gRDF.GetResource(serverUrl);

    // see if the URL already exists
    if (container.IndexOf(element) != -1) {
        var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
            .getService(Components.interfaces.nsIPromptService);
        var bundle = srGetStrBundle("chrome://annozilla/locale/prefs.properties");
        promptService.alert
            (window,
             bundle.GetStringFromName ("DUPLICATE_URL_TITLE"),
             bundle.formatStringFromName("DUPLICATE_URL_MESSAGE",[serverUrl],1)
             );
        return false;
    }

    container.AppendElement(element);

    // Overwrite the username and password - no longer used -
    // so that they are no longer stored
    assertForResource(element, "user", "noUser");
    assertForResource(element, "password", "noPassword");

    // flush the ds to disk.   
    var remoteDS = gDS.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
    remoteDS.Flush();

    // tell the opening window that a new server exists
    window.opener.gNewServerRV = gServerURL.value;
    window.close();  
}

/**
 * Assert a literal for a resource in the global
 * datasource.
 *
 * @param aResource Resource to assert the literal for
 * @param aPropertyString literal to assert
 * @param aValueString value for that literal
 */
function assertForResource(aResource, aPropertyString, aValueString)
{
    var valueProperty = gRDF.GetResource(SERVER_RDF(aPropertyString));
    var serverLiteral = gRDF.GetLiteral(aValueString);
    gDS.Assert(aResource, valueProperty, serverLiteral, true);
}

/**
 * Check the input fields to ensure
 * they're filled out properly.
 */
function checkInput() {
    return (document.getElementById("serverType").value == "local" ||
            gServerURL.value != "");
}
